#include <iostream>
#include <map>
#include <vector>
using namespace std;

struct point{
    bool color = 0;
    int self_num;
    vector<int> input;
    vector<int> output;

};
struct and_op{
    int i1, i2, o1;
};
struct not_op{
    int i1, o1;

};
map<int, point> points;
map<int, and_op> ands;
map<int, not_op> nots;
vector<int> ands_nums;
vector<int> nots_nums;
vector<int> pts_nums;

void update(){

    map<int, point> points_alt;
    for(int q = 0; q<nots_nums.size(); ++q){
        int i = nots_nums[q];
        not_op n = nots[i];
        points_alt[n.o1].color= points_alt[n.o1].color || !points[n.i1].color;
    }

    for(int q = 0; q<ands_nums.size(); ++q){
        int i = ands_nums[q];
        and_op a = ands[i];

        if(points[a.i1].color && points[a.i2].color){
            points_alt[a.o1].color = 1;
        }
    }


    for(int q = 0; q<pts_nums.size(); ++q){
        int i = pts_nums[q];
        point p = points[i];
        if(p.input.size() == 0){
            points_alt[p.self_num].color = p.color;
        }
    }

    points = points_alt;

}


int main()
{
    int and_ct = 2;
    int not_ct = 1;
    int n;
    cin >> n;
    int k, t;

    while(n--){
        int type;
        cin >> type;
        if(type == 0){
            int number, color;
            cin >> number >> color;
            points[number].color = color;
            points[number].self_num = number;
            pts_nums.push_back(number);
        }
        else if(type == 1){
            int in, ou;
            cin >> in >> ou;
            points[in].output.push_back(not_ct);
            points[ou].input.push_back(not_ct);
            nots[not_ct].i1 = in;
            nots[not_ct].o1 = ou;
            nots_nums.push_back(not_ct);
            not_ct += 2;
        }
        else if(type == 2){
            int i1,i2, o1;
            cin >> i1>>i2 >> o1;
            points[i1].output.push_back(and_ct);
            points[i2].output.push_back(and_ct);
            points[o1].input.push_back(and_ct);
            ands[and_ct].i1 = i1;
            ands[and_ct].i2 = i2;
            ands[and_ct].o1 = o1;
            ands_nums.push_back(and_ct);
            and_ct += 2;
        }
        else{
            cin >> k >> t;
        }
    }
    for(int i = 0; i<t; ++i){
        update();
        cout << points[k].color << endl;
    }
    return 0;
}
