#include <iostream>
#include <map>

using namespace std;

#define int long long

const int INF = 1e9+1;

void solve()
{
    string alf, h;
    int a, b;
    cin >> alf >> a >> b >> h;
    int k = alf.size();

    map <char, int> m;

    for (int i=0; i<k; i++) m[alf[i]] = i;

    int x = 0;
    for (auto i : h)
    {
        x *= k; x = min(x, INF);
        x += m[i];
    }
    int mod = 1;
    for (int i=0; i<h.size(); i++) {mod *= k; mod = min(mod, INF);}
    a += mod; b += mod;
    a -= x; b -= x;
    cout << b/mod - (a-1)/mod - (h[0] == alf[0] && x != 0);

    return;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tests = 1;

    #ifdef LOCAL
        cin >> tests;
    #endif

    for (int _=0; _<tests; _++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}