from collections import Counter

n, m = int(input()), int(input())

fields = [int(input()) for i in range(n)]
avg = sum(fields) / len(fields)
base_fields = []

for field in fields:
    if m < field < avg:
        base_fields.append(field)

a = Counter(base_fields)
total = a.most_common()

ans = (0, 0)
for (field, count) in total:
    if field > ans[0] and count >= ans[1]:
        ans = (field, count)

print(ans[0])