class Time:
    time = 0


class Dot:
    dots = []

    def __init__(self, num: int, state: bool):
        self.num = num
        self.__state = state
        self.dots.append(self)

    def set_state(self, state: bool):
        self.__state = state

    def get_state(self):
        return self.__state

    def action(self):
        pass


class AND:
    def __init__(self, input1: int, input2: int, output: int):
        for i in Dot.dots:
            if i.num == input1:
                self.input1 = i
            elif i.num == input2:
                self.input2 = i
            elif i.num == output:
                self.output = i

    def action(self):
        if self.input1.get_state() and self.input2.get_state():
            self.output.set_state(True)
        else:
            self.output.set_state(False)


class NOT:
    def __init__(self, input1: int, output: int):
        for i in Dot.dots:
            if i.num == input1:
                self.input1 = i
            elif i.num == output:
                self.output = i

    def action(self):
        self.output.set_state(not self.input1.get_state())


elems = []
for i in range(int(input())):
    string = input().split()
    if string[0] == '0':
        new_dot = Dot(int(string[1]), bool(int(string[2])))
        elems.append(new_dot)
    elif string[0] == '1':
        new_not = NOT(int(string[1]), int(string[2]))
        elems.append(new_not)
    elif string[0] == "2":
        new_and = AND(int(string[1]), int(string[2]), int(string[3]))
        elems.append(new_and)
    elif string[0] == '3':
        dot_num = int(string[1])
        time = int(string[2])

for i in range(time):
    for elem in elems:
        elem.action()
    for dot in Dot.dots:
        if dot.num == dot_num:
            print(int(dot.get_state()))
