#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define int long long

int binpow(int a, int p) {
    if (p == 0) return 1;
    if (p == 1) return a;
    if (p & 1) return binpow(a, p - 1) * a;
    return binpow(a, p >> 1) * binpow(a, p >> 1);
}

int get(string alf, string h, int r) {
    int n = alf.size();
    map<char, int> d;
    for (int i = 0; i < n; i++) d[alf[i]] = i;
    int mval = 0;
    string a;
    while (r) {
        a += alf[r % n];
        r /= n;
    }
    reverse(a.begin(), a.end());
    int nw = a.size() - h.size();
    string dop;
    for (int i = 0; i < nw; ++i) dop.push_back(alf[0]);
    if (a.size() < h.size()) a = dop + a;
    else h = dop + h;
    for (int i = 0; i < h.size(); ++i) {
        if (d[a[i]] > d[h[i]]) break;
        if (d[a[i]] < d[h[i]]) return 0;
    }
    ll ans = 0;
    for (int i = nw; i < h.size(); ++i) {
        if (d[a[i]] > d[h[i]]) {
            ans = 1;
            break;
        }
    }
    for (int i = 0; i < nw; ++i) {
        ans += binpow(n, nw - i - 1) * d[a[i]];
    }
    return ans;
}

void solve() {
    int a, b;
    string alf, h;
    cin >> alf >> a >> b >> h;
    cout << get(alf, h, b) - get(alf, h, a - 1);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}