base = 13
alf = "0123456789abc"
n = int(input())
changes = 0


def translate(num: int) -> str:
    cur = num
    s = ""
    while cur // base != 0:
        s += alf[cur % base]
        cur //= base
    s += alf[cur % base]
    cur //= base
    return "".join(reversed(s))


for _ in range(n):
    statements = translate(int(input()))
    for statement in statements:
        if statement in ["0", "6", "c"]:
            changes += 1

print(changes)
