#include <iostream>
#include <vector>

using namespace std;

#define int long long

const int INF = 1e18 + 17;

void solve()
{
    int n; cin >> n;
    int x; vector <int> v;
    for (int i=0; i<n; i++)
    {
        cin >> x;
        while (x)
        {
            if ((x % 13) % 6 == 0) v.push_back(x % 13);
            x /= 13; 
        }
    }
    int ans = (v.size() != 0);
    for (int i=1; i<v.size(); i++)
    {
        if (v[i] != v[i-1]) ans++;
    }
    cout << ans;
    return;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tests = 1;

    #ifdef LOCAL
        cin >> tests;
    #endif

    for (int _=0; _<tests; _++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}