#include <iostream>
#include <vector>

using namespace std;

#define int long long

const int INF = 1e18 + 17;

void solve()
{
    int n, m; cin >> n >> m;

    vector <int> a(n);
    for (int i=0; i<n; i++) cin >> a[i];

    double s=0;
    for (auto i : a) s += i;
    s /= n;

    vector <int> cnt(1001);
    for (auto i : a)
        if (i > m && i < s)
            cnt[i]++;
    int ans = 0;
    int mx = 0;
    for (int i=0; i<1001; i++)
    {
        if (cnt[i] >= mx)
        {
            ans = i;
            mx = cnt[i];
        }
    }
    cout << ans;
    return;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tests = 1;

    #ifdef LOCAL
        cin >> tests;
    #endif

    for (int _=0; _<tests; _++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}