#include <iostream>
#include <vector>
#include <map>

using namespace std;

#define int long long

const int INF = 1e18 + 17;

void solve()
{
    int n; cin >> n;
    vector <int> as1, as2, ae, is, ie;
    vector <int> p(100);

    int t, x, y, z, k, tt;
    for (int i=0; i<n; i++)
    {
        cin >> t;
        if(t == 0)
        {
            cin >> x >> y; x--;
            p[x] = y;
        }
        if (t == 1)
        {
            cin >> x >> y; x--; y--;
            is.push_back(x);
            ie.push_back(y);
        }
        if (t == 2)
        {
            cin >> x >> y >> z; x--; y--; z--;
            as1.push_back(x);
            as2.push_back(y);
            ae.push_back(z);
        }
        if (t == 3)
        {
            cin >> k >> tt; k--;
        }
    }

    int a=ae.size(), i=ie.size();
    for (int j=0; j<tt; j++)
    {
        map <int, int> temp;
        for (int q=0; q<a; q++)
        {
            if (p[as1[q]] && p[as2[q]]) temp[ae[q]] = 1;
            else
            {
                if (!temp.count(ae[q])) temp[ae[q]] = 0;
            }
        }
        for (int q=0; q<i; q++)
        {
            if ((!temp.count(ie[q])) || (temp[ie[q]] == 0)) temp[ie[q]] = 1-p[is[q]];
        }
        for (int q=0; q<100; q++)
        {
            if (temp.count(q)) p[q] = temp[q];
        }
        cout << p[k] << '\n';
    }

    return;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int tests = 1;

    #ifdef LOCAL
        cin >> tests;
    #endif

    for (int _=0; _<tests; _++)
    {
        solve();
        cout << '\n';
    }

    return 0;
}